spack:
  view: false

  concretizer:
    reuse: false
    unify: false

  packages:
    all:
      require: '%gcc@11.2.0'
      providers:
        blas: [openblas]
        lapack: [openblas]
        mpi: [cray-mpich]
        tbb: [intel-tbb]
        scalapack: [netlib-scalapack]
      target: [zen3]
      variants: +mpi cuda_arch=80
    tbb:
      require: intel-tbb
    mpi:
      require: cray-mpich
    cuda:
      require: "@11.4.4 +allow-unsupported-compilers"
    binutils:
      variants: +ld +gold +headers +libiberty ~nls
    elfutils:
      variants: +bzip2 ~nls +xz
    hdf5:
      variants: +fortran +hl +shared
    libunwind:
      variants: +pic +xz
    ncurses:
      require: '@6.3 +termlib'
    openblas:
      variants: threads=openmp
    trilinos:
      variants: +amesos +amesos2 +anasazi +aztec +belos +boost +epetra +epetraext
        +ifpack +ifpack2 +intrepid +intrepid2 +isorropia +kokkos +ml +minitensor +muelu
        +nox +piro +phalanx +rol +rythmos +sacado +stk +shards +shylu +stokhos +stratimikos
        +teko +tempus +tpetra +trilinoscouplings +zoltan +zoltan2 +superlu-dist gotype=long_long
    xz:
      variants: +pic
    mesa:
      version: [21.3.8]
    petsc:
      variants: +batch
    parallel-netcdf:
      variants: +cxx +fortran +fpic
    netlib-scalapack:
      variants: +fpic
    netcdf-c:
      variants: ~hdf4 +mpi +parallel-netcdf +shared
    fftw:
      variants: precision=float,double,long_double
    darshan-runtime:
      variants: scheduler=slurm
    paraview:
      require: ~qt +osmesa
    visit:
      require: ~gui +osmesa
    vtk-m:
      require: +examples
    libfabric:
      buildable: false
      externals:
      - spec: libfabric@1.11
        modules:
        - libfabric/1.11.0.4.125
    cray-mpich:
      buildable: false
      externals:
      - spec: cray-mpich@8.1.16 %gcc@11.2.0
        prefix: /opt/cray/pe/mpich/default/ofi/gnu/9.1
        modules:
        - cray-mpich/8.1.16
        - libfabric/1.11.0.4.125
    openssl:
      buildable: false
      externals:
      - spec: openssl@1.1.1d
        prefix: /usr

  compilers:
  - compiler:
      spec: gcc@11.2.0
      paths:
        cc: gcc
        cxx: g++
        f77: gfortran
        fc: gfortran
      flags: {}
      operating_system: sles15
      target: any
      modules:
      - PrgEnv-gnu
      - gcc/11.2.0
      environment: {}
      extra_rpaths: []

  specs:
  # CPU
  - adios
  - alquimia
  - aml
  - amrex
  - arborx
  - argobots
  - axom
  - bolt
  - boost +python +filesystem +iostreams +system
  - butterflypack
  - cabana
  - caliper
  - chai ~benchmarks ~tests
  - charliecloud
  - conduit
  - datatransferkit
  - dealii ^trilinos~shylu
  - dyninst
  - flecsi
  - flit
  - flux-core
  - fortrilinos
  - gasnet
  - ginkgo
  - globalarrays
  - gmp
  - gotcha
  - gptune ~mpispawn
  - h5bench
  - hdf5-vol-async
  - hdf5-vol-cache
  - hdf5-vol-log
  - heffte +fftw
  - hpctoolkit
  - hpx max_cpu_count=512 networking=mpi
  - hypre
  - kokkos +openmp
  - kokkos-kernels +openmp
  - lammps
  - legion
  - libnrm
  - libpressio +bitgrooming +bzip2 ~cuda ~cusz +fpzip +hdf5 +libdistributed +lua +openmp +python +sz +sz3 +unix +zfp
  - libquo
  - libunwind
  - loki
  - metall
  - mfem
  - mgard +serial +openmp +timing +unstructured ~cuda
  - mpark-variant
  - mpifileutils ~xattr
  - nccmp
  - nco
  - netlib-scalapack
  - nrm
  - omega-h
  - openfoam
  - openmpi
  - openpmd-api
  - papi
  - papyrus
  - parsec ~cuda
  - pdt
  - petsc
  - phist
  - plasma
  - plumed
  - precice
  - pruners-ninja
  - pumi
  - py-h5py
  - py-jupyterhub
  - py-libensemble +mpi +nlopt
  - py-petsc4py
  - py-warpx
  - qthreads scheduler=distrib
  - quantum-espresso
  - raja
  - rempi
  - scr
  - slate ~cuda
  - slepc
  - stc
  - strumpack ~slate
  - sundials
  - superlu
  - superlu-dist
  - swig@4.0.2-fortran
  - sz3
  - tasmanian
  - tau +mpi +python
  - trilinos +amesos +amesos2 +anasazi +aztec +belos +boost +epetra +epetraext +ifpack +ifpack2 +intrepid +intrepid2 +isorropia +kokkos +ml +minitensor +muelu +nox +piro +phalanx +rol +rythmos +sacado +stk +shards +shylu +stokhos +stratimikos +teko +tempus +tpetra +trilinoscouplings +zoltan +zoltan2 +superlu-dist gotype=long_long
  - turbine
  - umap
  - umpire
  - variorum
  - wannier90
  - xyce +mpi +shared +pymi +pymi_static_tpls ^trilinos~shylu
  # INCLUDED IN ECP DAV CPU
  # - ecp-data-vis-sdk ~cuda ~rocm +adios2 +ascent +cinema +darshan +faodel +hdf5 +paraview +pnetcdf +sz +unifyfs +veloc +visit +vtkm +zfp # adios2~cuda, ascent~cuda, darshan-runtime, darshan-util, faodel, hdf5, libcatalyst, parallel-netcdf, paraview~cuda, py-cinemasci, sz, unifyfs, veloc, visit, vtk-m, zfp
  # - adios2
  # - ascent
  # - darshan-runtime
  # - darshan-util
  # - faodel
  # - hdf5
  # - libcatalyst
  # - parallel-netcdf
  # - paraview
  # - py-cinemasci
  # - sz
  # - unifyfs
  # - veloc
  # - visit                           # failed silo: https://github.com/spack/spack/issues/39538
  # - vtk-m
  # - zfp
  # --
  # - archer                          # submerged into llvm +libomp_tsan
  # - bricks ~cuda                    # bricks: weak/args.h:14:8: error: 'size_t' does not namea type
  # - exaworks                        # rust: error: failed to get `cc` as a dependency of package `bootstrap v0.0.0: Problem with the SSL CA cert (path? access rights?) (error setting certificate verify locations:  CAfile: /usr/etc/openssl/cert.pem CA path: /etc/ssl/certs)
  # - geopm                           # geopm: https://github.com/spack/spack/issues/38795
  # - lbann                           # dihydrogen: CMake Error at CMakeLists.txt:196 (find_package): Could not find a package configuration file provided by "Hydrogen"
  # - mercury                         # mercury: na/na_ofi.c:33:10: fatal error: rdma/fi_ext.h: No such file or directory
  # - upcxx                           # upcxx: ld: /opt/cray/pe/mpich/8.1.16/gtl/lib/libmpi_gtl_cuda.so: undefined reference to `cudaEventDestroy@@libcudart.so.11.0'

  # CUDA NOARCH
  - cabana +cuda ^kokkos +wrapper +cuda_lambda +cuda cuda_arch=80
  - flux-core +cuda
  - hpctoolkit +cuda
  - papi +cuda
  - tau +mpi +cuda
  - legion +cuda                      # legion: needs NVIDIA driver  
  # --
  # - bricks +cuda                    # bricks: weak/args.h:14:8: error: 'size_t' does not namea type

  # CUDA 80
  - amrex +cuda cuda_arch=80
  - arborx +cuda cuda_arch=80 ^kokkos +wrapper
  - caliper +cuda cuda_arch=80
  - chai ~benchmarks ~tests +cuda cuda_arch=80 ^umpire ~shared
  - cusz +cuda cuda_arch=80
  - flecsi +cuda cuda_arch=80
  - ginkgo +cuda cuda_arch=80
  - heffte +cuda cuda_arch=80
  - hpx +cuda cuda_arch=80
  - hypre +cuda cuda_arch=80
  - kokkos +wrapper +cuda cuda_arch=80
  - kokkos-kernels +cuda cuda_arch=80 ^kokkos +wrapper +cuda cuda_arch=80
  - lammps +cuda cuda_arch=80         # lammps: needs NVIDIA driver
  - magma +cuda cuda_arch=80
  - mfem +cuda cuda_arch=80
  - mgard +serial +openmp +timing +unstructured +cuda cuda_arch=80
  - omega-h +cuda cuda_arch=80
  - parsec +cuda cuda_arch=80
  - petsc +cuda cuda_arch=80
  - raja +cuda cuda_arch=80
  - slate +cuda cuda_arch=80
  - slepc +cuda cuda_arch=80
  - strumpack ~slate +cuda cuda_arch=80
  - sundials +cuda cuda_arch=80
  - superlu-dist +cuda cuda_arch=80
  - tasmanian +cuda cuda_arch=80
  - umpire ~shared +cuda cuda_arch=80
  - upcxx +cuda cuda_arch=80          # upcxx: needs NVIDIA driver
  # INCLUDED IN ECP DAV CUDA
  # - ecp-data-vis-sdk ~rocm +adios2 ~ascent +hdf5 +vtkm +zfp +paraview +cuda cuda_arch=80 # +ascent fails because fides fetch error
  # - adios2 +cuda cuda_arch=80
  # - ascent +cuda cuda_arch=80       # failed ascent: https://github.com/spack/spack/issues/38045
  # - paraview +cuda cuda_arch=80
  # - vtk-m +cuda cuda_arch=80
  # - zfp +cuda cuda_arch=80
  # --
  # - axom +cuda cuda_arch=80         # axom: https://github.com/spack/spack/issues/29520
  # - dealii +cuda cuda_arch=80       # dealii: FAILED: cmake/scripts/CMakeFiles/expand_instantiations_exe.dir/expand_instantiations.cc.o: /home/abuild/rpmbuild/BUILD/glibc-2.31/csu/../sysdeps/x86_64/start.S:104: undefined reference to `main'
  # - lbann +cuda cuda_arch=80        # lbann: https://github.com/spack/spack/issues/38788
  # - libpressio +bitgrooming +bzip2 +fpzip +hdf5 +libdistributed +lua +openmp +python +sz +sz3 +unix +zfp +json +remote +netcdf +cusz +mgard +cuda cuda_arch=80 ^cusz +cuda cuda_arch=80 # conflict with cuda@11.4.4
  # - py-torch +cuda cuda_arch=80     # skipped
  # - trilinos +cuda cuda_arch=80     # trilinos: The C++ compiler "/opt/cray/pe/mpich/default/ofi/gnu/9.1/bin/mpicxx" is not able to compile a simple test program. ; g++: error: unrecognized command-line option '--expt-extended-lambda'

  # - nvhpc                           # provided by systems staff
